> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Get unspent transaction outputs containing Bitcoin Runes tokens for a specific address.

# Rune UTxOs by Address



## OpenAPI

````yaml bitcoin/blockchain-indexer-api/openapi.json get /addresses/{address}/runes/utxos
openapi: 3.0.3
info:
  title: Bitcoin - Blockchain Indexer API
  description: >-
    This API provides core indexer endpoints with support for Bitcoin
    metaprotocols by delivering real-time, rollback-protected access to
    Bitcoin's UTXO data, enabling developers to build responsive and reliable
    blockchain applications without managing complex infrastructure.


    #### Key Features:

    - **Real-Time Data with Rollback Protection:** Ensures data accuracy by
    handling chain reorganizations gracefully, providing live data without
    sacrificing integrity.

    - **Comprehensive UTXO Indexing:** Specialized pipelines extract, match, and
    process on-chain information, including handling rollbacks, to provide
    accurate and up-to-date data.


    #### Key Benefits for Developers:

    By abstracting the complexities of blockchain data retrieval and processing,
    Maestro's Bitcoin Indexer API empowers developers to focus on building
    innovative applications with confidence in fast and reliable access to
    historical chain data.
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v0.2.0
servers:
  - url: https://xbt-mainnet.gomaestro-api.org/v0
    description: Bitcoin Mainnet
  - url: https://xbt-testnet.gomaestro-api.org/v0
    description: Bitcoin Testnet
security:
  - api-key: []
paths:
  /addresses/{address}/runes/utxos:
    get:
      tags:
        - Addresses
      summary: Rune UTxOs by Address
      description: >-
        Lists all UTXOs at the address or script pubkey that contains Rune
        tokens, with optional refinement based on Rune type or metadata. Helpful
        for spend analysis or wallet state audits.
      operationId: rune_utxos_by_address_v2
      parameters:
        - name: address
          in: path
          description: Bitcoin address or hex encoded script pubkey
          required: true
          schema:
            type: string
          example: bc1p27j3fa2mr3d50m3uaavr0ntyzr0v2a27n48lc9gxpkzd4xye6dgs2tzx6p
        - name: rune
          in: query
          description: >-
            Return only UTxOs containing a specific Rune, specified either by
            the Rune ID (etching block number and transaction index) or name
            (spaced or un-spaced)
          required: false
          schema:
            type: string
            nullable: true
          example: '840000:3'
        - name: order_by
          in: query
          description: >-
            The property by which response items should be sorted. Supported
            values: height (height of block which produced the UTxO - default),
            amount (amount of runes in UTxO)
          required: false
          schema:
            allOf:
              - $ref: '#/components/schemas/OrderBy'
            nullable: true
        - name: order
          in: query
          description: >-
            The order in which the results are sorted. Supported values: asc,
            desc
          required: false
          schema:
            allOf:
              - type: string
                default: asc
                enum:
                  - asc
                  - desc
            nullable: true
        - name: count
          in: query
          description: The max number of results per page
          required: false
          schema:
            allOf:
              - type: integer
                default: 100
                minimum: 0
            nullable: true
        - name: cursor
          in: query
          description: >-
            Pagination cursor string, use the cursor included in a page of
            results to fetch the next page.
          required: false
          schema:
            type: string
            nullable: true
        - name: from
          in: query
          description: Return only UTxOs created on or after a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: to
          in: query
          description: Return only UTxOs created on or before a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
      responses:
        '200':
          description: Requested data
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedRuneUtxoByAddress'
              example:
                data:
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 3
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 4
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 5
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 6
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 7
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 8
                  - confirmations: 13636
                    height: 876954
                    runes:
                      - amount: '2500000'
                        rune_id: '876947:7'
                    satoshis: '546'
                    txid: >-
                      67715c2b42eaa053fc174c68ca4f393446986567ed0509fa78eb3aa9d0b8db0b
                    vout: 9
                last_updated:
                  block_hash: >-
                    00000000000000000000e0b35ac5973cb61e9994c78b83d20f75f4b8f8d54fff
                  block_height: 890589
                next_cursor: null
        '400':
          description: Malformed query parameters
        '404':
          description: Requested entity not found on-chain
        '500':
          description: Internal server error
components:
  schemas:
    OrderBy:
      type: string
      default: height
      enum:
        - height
        - amount
    PaginatedRuneUtxoByAddress:
      type: object
      required:
        - data
        - last_updated
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/RuneUtxoByAddress'
        last_updated:
          $ref: '#/components/schemas/ChainTip'
        next_cursor:
          type: string
          nullable: true
    RuneUtxoByAddress:
      type: object
      required:
        - txid
        - vout
        - satoshis
        - confirmations
        - height
        - runes
      properties:
        confirmations:
          type: integer
          format: int64
          minimum: 0
        height:
          type: integer
          format: int64
          minimum: 0
        runes:
          type: array
          items:
            $ref: '#/components/schemas/RuneAndAmount'
        satoshis:
          type: string
        txid:
          type: string
        vout:
          type: integer
          format: int32
          minimum: 0
    ChainTip:
      type: object
      required:
        - block_hash
        - block_height
      properties:
        block_hash:
          type: string
          description: The hash of the block
          example: 0000000000000000000a7f3b7b6b6e1d9a18db65a3b4a3f4f3bcb2e1f1b2d3e7
        block_height:
          type: integer
          format: int64
          description: The height of the block in the blockchain
          example: 707000
          minimum: 0
    RuneAndAmount:
      type: object
      required:
        - rune_id
        - amount
      properties:
        amount:
          type: string
        rune_id:
          type: string
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````